using System;
using Microsoft.Win32;
using System.Collections;

namespace WindowsApplication1
{
	/// <summary>
	/// RegistryUtility ̊Tv̐łB
	/// </summary>
	public class RegistryUtility
	{
		private RegistryUtility()
		{
		}

		private static bool GetKeyTypeAndPath(string fullpath, ref string keytype, ref string keypath)
		{
			int indexComputer = fullpath.IndexOf("\\");
			if (indexComputer == -1)
			{
				return false;
			}
			int indexKey = fullpath.IndexOf("\\", indexComputer + 1);
			if (indexKey == -1)
			{
				keytype = fullpath.Substring(indexComputer + 1);
				keypath = "";
			} 
			else
			{
				keytype = fullpath.Substring(indexComputer + 1,	indexKey - indexComputer - 1);
				keypath = fullpath.Substring(indexKey + 1);
			}
			return true;
		}

		private static RegistryKey GetRegistryKey(string keytype, string keypath)
		{
			RegistryKey rKey;
			switch (keytype)
			{
				case "HKEY_CLASSES_ROOT":
					rKey = Registry.ClassesRoot.OpenSubKey(keypath);
					break;
				case "HKEY_CURRENT_USER":
					rKey = Registry.CurrentUser.OpenSubKey(keypath);
					break;
				case "HKEY_LOCAL_MACHINE":
					rKey = Registry.LocalMachine.OpenSubKey(keypath);
					break;
				case "HKEY_USERS":
					rKey = Registry.Users.OpenSubKey(keypath);
					break;
				case "HKEY_CURRENT_CONFIG":
					rKey = Registry.CurrentConfig.OpenSubKey(keypath);
					break;
				default:
					return null;
			}
			return rKey;
		}

		public static string[] GetSubKeys(string fullpath)
		{
			string keytype = "";
			string keypath = "";

			ArrayList arrayString = new ArrayList();

			try
			{
				bool bValidKey = GetKeyTypeAndPath(fullpath, ref keytype, ref keypath);
				if (bValidKey == false)
				{
					throw(new Exception());
				}

				RegistryKey rKey = GetRegistryKey(keytype, keypath);
				if (rKey == null)
				{
					throw(new Exception());
				}
				foreach(string keyName in rKey.GetSubKeyNames())
				{
					arrayString.Add(keyName);
				}
				rKey.Close();
			}
			catch (Exception)
			{
			}

			return (string[])arrayString.ToArray(typeof(string));
		}

		public static string[][] GetValues(string fullpath)
		{
			string keytype = "";
			string keypath = "";

			ArrayList arrayStringArray = new ArrayList();

			object data;
			try
			{
				bool bValidKey = GetKeyTypeAndPath(fullpath, ref keytype, ref keypath);
				if (bValidKey == false)
				{
					throw(new Exception());
				}

				RegistryKey rKey = RegistryUtility.GetRegistryKey(keytype, keypath);
				if (rKey == null)
				{
					throw(new Exception());
				}

				string dafualtValue = (string)rKey.GetValue("");
				arrayStringArray.Add(
					new string[] {"()",
									 "REG_SZ",
									 (dafualtValue != null) ?
									 dafualtValue : "(l̐ݒȂ)"}
					);

				foreach(string valueName in rKey.GetValueNames())
				{
					if (valueName == "")
					{
						continue;
					}

					data = rKey.GetValue(valueName);

					if (data is String)
					{
						arrayStringArray.Add(
							new string[] {valueName,
											 "REG_SZ",
											 data.ToString()});
					}
					else if (data is Int32)
					{
						Int64 temp = (Int32)data;
						if (temp < 0)
						{
							temp += 0xFFFFFFFF;
							temp++;
						}
						arrayStringArray.Add(
							new string[] {valueName, "REG_DWORD",
											 String.Format("0x{0:x8} ({1:d})",
											 ((Int32)data), temp)});
					}
					else if (data is Byte[])
					{
						string bytedata = "";
						if (((Byte[])data).Length == 0)
						{
							bytedata = "( 0 ̃oCil)";
						}
						for (int i = 0; i < ((Byte[])data).Length; i++) 
						{
							if (i > 70)
							{
								bytedata += "...";
								break;
							}
							bytedata += String.Format("{0:x2} ",
								((Byte[])data)[i]);
						}

						arrayStringArray.Add(
							new string[] {valueName, "REG_BINARY", bytedata});
					}
					else if (data is String[])
					{
						int sumLength = 0;
						string multidata = "";
						for (int i = 0; i < ((String[])data).Length; i++) 
						{
							if (sumLength > 210)
							{
								multidata += "...";
								break;
							}
							multidata += String.Format("{0} ",
								((String[])data)[i]);
							sumLength += ((String[])data)[i].Length;
						}
						arrayStringArray.Add(
							new string[] {valueName, "REG_MULTI_SZ", multidata});
					}
					else
					{
						//REG_RESOURCE_LISTREG_RESOURCE_LIST 
						arrayStringArray.Add(
							new string[] {valueName,
											 ".NETΉ̃f[^^ł",
											 "f[^QƁE삷邱͂ł܂"});
					}
				}
				rKey.Close();
			}
			catch (Exception)
			{
			}

			return (string[][])arrayStringArray.ToArray(typeof(string[]));
		}
	}
}
